<?php
# sspp.php ( Server Status PHP Parser )

#########################################################################
# Version 0.1 Created by Serghey Rodin  skid@linux.md                   #
# Version 0.2 Modded by Alexandr Chalpet chalpet@ceonex.com             #
# Version 0.3 Modded by Dmitry Naumov Socolov naumov.socolov@gmail.com  #
# Version 0.4 Modded by Egor golden@ceonex.com                          #
#                                                                       #
# This script is freely distributable under the                         #
# GNU GENERAL PUBLIC LICENSE Version 3                                  #
# http://www.gnu.org/licenses/gpl-3.0.txt                               #
# ##################################################################### #

# If you want to contribute, please welcome :)

# Temporary file path
define('FILE', '/tmp/sspp.raw');

# Hiding errors
error_reporting('E_NONE');

# Ucoment this if you are developer
//error_reporting(E_ALL);

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
<head>
    <title> SSPP - Server Status PHP Parser </title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
    <meta http-equiv="Cache-Control" content="no-cache" >
    <meta http-equiv="Pragma" content="no-cache" >
    <style type="text/css">

	table{
	        background:gray;
	    }

	td{
	        background:white;
		color: black
	    }
	th,th a{
		font-weight:bold;
	        color:white;
		background:gray;
	    }
	form {
		padding: 20px;
	}
	input {
		margin: 0 20px;
		padding: 5px;
	}
    </style>
</head>
<body>
<h1>SSPP - Server Status PHP Parser</h1><hr>
<form method="post" action="">
    Server-Status URL: <input type=text size=40 name=url
	 value="http://localhost/server-status">
    <input type=submit value="Get status">
</form>

<?php

########################
# :: Function List ::  #
########################

# Get server-status
function get_status($url)
{
    # Defining error messages
    $error_message1 = " Sorry, can't work with empty url";
    $error_message2 = " Sorry, can't parse this url... shame on me";
    $error_message3 = " Sorry, I've got an error from web-server";
    $error_message4 = " Sorry, can't write to".FILE.". Check permissions";

    # Cheking server-status url
    # Ok, I do not know how to work httpd error codes and file_get_contents
    # I hope someday I will make error handler for webserver respones too.
    if(empty($url))
    {
	echo $error_message1 ;
	exit;
    }

    # Trying to get server-status
    if( false == ($str=file_get_contents($url)))
    {
	echo $error_message3;
	exit;
    }
    
    $str = str_replace("\r", "", $str);     # removing \r
    $str = str_replace("\n", "", $str);     # removing \n

    # Eah big regexp... we just need field values from server-status
    $reg='~<tr><td><b>(.*)<\/b><\/td><td>(.*)<\/td><td>(.*)<\/td>';
    $reg.='<td>(.*)<\/td><td>(.*)<\/td><td>(.*)<\/td><td>(.*)<\/td>';
    $reg.='<td>(.*)<\/td><td>(.*)<\/td><td>(.*)<\/td><td>(.*)<\/td>';
    $reg.='<td nowrap>(.*)<\/td><td nowrap>(.*)<\/td><\/tr>~Ui';
    preg_match_all($reg, $str, $matches);

    # Checking how many records we found.
    # Simple handler, but it works sometime
    $c = count($matches[0]);
    if( $c == 0 )
    {
	echo $error_message2;
	exit;
    }

    # Checking file permissions
    if( false == ($f = fopen(FILE,'w')))
    {
	echo $error_message4;
	exit;
    }

    # Wheeee... filling arrays 
    for($i=1;$i<$c;$i++)
    {
	$out['result'][$i]['srv'] = $matches[1][$i];
	$out['result'][$i]['pid'] = $matches[2][$i];
        $out['result'][$i]['acc'] = $matches[3][$i];
        $out['result'][$i]['m'] = $matches[4][$i];
        $out['result'][$i]['cpu'] = $matches[5][$i];
        $out['result'][$i]['ss'] = $matches[6][$i];
        $out['result'][$i]['req'] = $matches[7][$i];
        $out['result'][$i]['conn'] = $matches[8][$i];
        $out['result'][$i]['child'] = $matches[9][$i];
        $out['result'][$i]['slot'] = $matches[10][$i];
        $out['result'][$i]['client'] = $matches[11][$i];
        $out['result'][$i]['vhost'] = $matches[12][$i];
        $out['result'][$i]['request'] = $matches[13][$i];

	# We will need this array later for uniq sort
        $out['counts']['vhosts'][$matches[12][$i]]++;
        $out['counts']['clients'][$matches[11][$i]]++;
	$out['counts']['requests'][$matches[13][$i]]++;
    }

    # Analiser stuff that makes administrators happy
    # We just sorting arrays btw
    arsort($out['counts']['vhosts']);
    arsort($out['counts']['clients']);
    arsort($out['counts']['requests']);

    # Now we will concatenate arrays
    $arr_str = serialize($out);

    # Writing to temporary file
    fwrite($f, $arr_str);
    fclose($f);
}


# Show server-status
function show_status($sort)
{

    # Parsing temp file with server-status data
    $requests_arr = unserialize(file_get_contents(FILE));

    # Getting sort variable
    if(isset($_GET['sort']) && $_GET['sort']) $sort = $_GET['sort'];
    else $sort = 'cpu';

    # Creating new array and sorting it by user request
    foreach($requests_arr['result'] as $request)
        $sortAux[] = $request[$sort];

    # Set proper search type for sort
    switch ($sort)
    {
	case 'srv';	# Child Server number - generation
	case 'pid';	# OS process ID
	case 'acc';	# Number of accesses this connection
	case 'cpu';	# CPU usage, number of seconds
	case 'ss';	# Seconds since beginning of most recent request
	case 'req';	# Milliseconds required to process most recent request
	case 'conn';	# Kilobytes transferred this connection
	case 'child';	# Megabytes transferred this child
	case 'slot';	# Total megabytes transferred this slot

	    array_multisort($sortAux, SORT_ASC, $requests_arr['result']);
	    break;
	case 'm';	# Mode of operation
	case 'client';	# Client's ip address
	case 'vhost';	# VirtualHost name
	case 'request';	# HTTP request string

	    array_multisort($sortAux, SORT_STRING, $requests_arr['result']);
	    break;
    }

    # Lets draw main table
    echo "<table width=\"100%\" cellpadding=\"3\" cellspacing=\"1\">
	<tr align=\"center\">
	\t<th><a href=\"?sort=srv\">Srv</a></th>
	\t<th><a href=\"?sort=pid\">PID</a></th>
	\t<th><a href=\"?sort=acc\">Acc</a></th>
	\t<th><a href=\"?sort=m\">M</a></th>
	\t<th><a href=\"?sort=cpu\">CPU</a></th>
	\t<th><a href=\"?sort=ss\">SS</a></th>
	\t<th><a href=\"?sort=req\">Req</a></th>
	\t<th><a href=\"?sort=conn\">Conn</a></th>
	\t<th><a href=\"?sort=child\">Child</a></th>
	\t<th><a href=\"?sort=slot\">Slot</a></th>
	\t<th><a href=\"?sort=client\">Client</a></th>
	\t<th><a href=\"?sort=vhost\">VHost</a></th>
	\t<th><a href=\"?sort=request\">Request</a></th>
	</tr>\n";

    # And print server-status array
    foreach($requests_arr['result'] as $request) {
	echo "\t<tr>\n";
	foreach($request as $param) {
	    echo "\t\t<td>".$param."</td>\n";
	}
	echo "\t</tr>\n";
    }
    # Closing main table
    echo "\n</table>\n<br>\n";


    # Lets print some analytics, table head first
    echo "<table width=\"100%\" cellpadding=\"0\" cellspacing=\"1\">
	<tr align=\"center\">\n\t\t<th>Vhosts</th>\n\t\t<th>Clients</th>
	\t<th>Requests</th>\n\t</tr>\n\t<tr valign=top>\n";

    # Temporary array with proper names just for list;
    $counts_name = array ('vhosts','clients','requests');

    # Printing data by temporary array
    foreach( $counts_name as $name)
    {
	# html table
        echo "\t\t<td>\n\t\t\t<table width=\"100%\">\n";
	# little hack for top ten
	$i = 1;
	foreach($requests_arr['counts'][$name] as $k => $v)
	{
	    if ($i > 10) break;
	    $i++;

	    echo "\t\t\t\t<tr>\n";
	    echo "\t\t\t\t\t<td>".$k."</td><td>".$v."</td>\n";
	    echo "\t\t\t\t</tr>\n";
	}
	echo "\t\t\t</table>\n\t\t</td>\n";
    }

    # Closing table and whole html document
    echo "\t\t\t</table>\n\t\t</td>\n\t</tr>\n</table>\n</body>\n</html>\n";
}

#########################
# :: Rock&Roll baby ::  #
#########################

# Checking POST data
if(isset($_POST['url']))
{
    $url = $_POST['url'];
    get_status($url);
    show_status('cpu');
}

# Checking GET data
if(isset($_GET['sort']) && !isset($_POST['url']))
{
    $sort = $_GET['sort'];
    show_status($sort);
}
